Skip to content

Lambda  >  Operations  >  update_function_code

update_function_code

Operation

update_function_code async

update_function_code(input: UpdateFunctionCodeInput, plugins: list[Plugin] | None = None) -> UpdateFunctionCodeOutput

Updates a Lambda function's code. If code signing is enabled for the function, the code package must be signed by a trusted publisher. For more information, see Configuring code signing for Lambda.

If the function's package type is Image, then you must specify the code package in ImageUri as the URI of a container image in the Amazon ECR registry.

If the function's package type is Zip, then you must specify the deployment package as a .zip file archive. Enter the Amazon S3 bucket and key of the code .zip file location. You can also provide the function code inline using the ZipFile field.

The code in the deployment package must be compatible with the target instruction set architecture of the function (x86-64 or arm64).

The function's code is locked when you publish a version. You can't modify the code of a published version, only the unpublished version.

Note

For a function defined as a container image, Lambda resolves the image tag to an image digest. In Amazon ECR, if you update the image tag to a new image, Lambda does not automatically update the function.

Parameters:

Name Type Description Default
input UpdateFunctionCodeInput

An instance of UpdateFunctionCodeInput.

required
plugins list[Plugin] | None

A list of callables that modify the configuration dynamically. Changes made by these plugins only apply for the duration of the operation execution and will not affect any other operation invocations.

None

Returns:

Type Description
UpdateFunctionCodeOutput

An instance of UpdateFunctionCodeOutput.

Input

UpdateFunctionCodeInput dataclass

Dataclass for UpdateFunctionCodeInput structure.

Attributes

architectures class-attribute instance-attribute
architectures: list[Architecture] | None = None

The instruction set architecture that the function supports. Enter a string array with one of the valid values (arm64 or x86_64). The default value is x86_64.

dry_run class-attribute instance-attribute
dry_run: bool = False

Set to true to validate the request parameters and access permissions without modifying the function code.

function_name class-attribute instance-attribute
function_name: str | None = None

The name or ARN of the Lambda function.

Name formats

  • Function name -- my-function.

  • Function ARN -- arn:aws:lambda:us-west-2:123456789012:function:my-function.

  • Partial ARN -- 123456789012:function:my-function.

The length constraint applies only to the full ARN. If you specify only the function name, it is limited to 64 characters in length.

image_uri class-attribute instance-attribute
image_uri: str | None = None

URI of a container image in the Amazon ECR registry. Do not use for a function defined with a .zip file archive.

publish class-attribute instance-attribute
publish: bool = False

Set to true to publish a new version of the function after updating the code. This has the same effect as calling PublishVersion separately.

publish_to class-attribute instance-attribute
publish_to: FunctionVersionLatestPublished | None = None

Specifies where to publish the function version or configuration.

revision_id class-attribute instance-attribute
revision_id: str | None = None

Update the function only if the revision ID matches the ID that's specified. Use this option to avoid modifying a function that has changed since you last read it.

s3_bucket class-attribute instance-attribute
s3_bucket: str | None = None

An Amazon S3 bucket in the same Amazon Web Services Region as your function. The bucket can be in a different Amazon Web Services account. Use only with a function defined with a .zip file archive deployment package.

s3_key class-attribute instance-attribute
s3_key: str | None = None

The Amazon S3 key of the deployment package. Use only with a function defined with a .zip file archive deployment package.

s3_object_storage_mode class-attribute instance-attribute
s3_object_storage_mode: S3ObjectStorageMode | None = None

Specifies how the deployment package is stored. Valid values:

  • COPY (default) -- Uploads a copy of your deployment package to Lambda.

  • REFERENCE -- Lambda references the deployment package from the specified Amazon S3 bucket.

s3_object_version class-attribute instance-attribute
s3_object_version: str | None = None

For versioned objects, the version of the deployment package object to use.

source_kms_key_arn class-attribute instance-attribute
source_kms_key_arn: str | None = None

The ARN of the Key Management Service (KMS) customer managed key that's used to encrypt your function's .zip deployment package. If you don't provide a customer managed key, Lambda uses an Amazon Web Services managed key.

zip_file class-attribute instance-attribute
zip_file: bytes | None = field(repr=False, default=None)

The base64-encoded contents of the deployment package. Amazon Web Services SDK and CLI clients handle the encoding for you. Use only with a function defined with a .zip file archive deployment package.

Output

UpdateFunctionCodeOutput dataclass

Details about a function's configuration.

Attributes

architectures class-attribute instance-attribute
architectures: list[Architecture] | None = None

The instruction set architecture that the function supports. Architecture is a string array with one of the valid values. The default architecture value is x86_64.

capacity_provider_config class-attribute instance-attribute
capacity_provider_config: CapacityProviderConfig | None = None

Configuration for the capacity provider that manages compute resources for Lambda functions.

code_sha256 class-attribute instance-attribute
code_sha256: str | None = None

The SHA256 hash of the function's deployment package.

code_size class-attribute instance-attribute
code_size: int = 0

The size of the function's deployment package, in bytes.

config_sha256 class-attribute instance-attribute
config_sha256: str | None = None

The SHA256 hash of the function configuration.

dead_letter_config class-attribute instance-attribute
dead_letter_config: DeadLetterConfig | None = None

The function's dead letter queue.

description class-attribute instance-attribute
description: str | None = None

The function's description.

durable_config class-attribute instance-attribute
durable_config: DurableConfig | None = None

The function's durable execution configuration settings, if the function is configured for durability.

environment class-attribute instance-attribute
environment: EnvironmentResponse | None = None

The function's environment variables. Omitted from CloudTrail logs.

ephemeral_storage class-attribute instance-attribute
ephemeral_storage: EphemeralStorage | None = None

The size of the function's /tmp directory in MB. The default value is 512, but can be any whole number between 512 and 10,240 MB. For more information, see Configuring ephemeral storage (console).

file_system_configs class-attribute instance-attribute
file_system_configs: list[FileSystemConfig] | None = None

Connection settings for an Amazon EFS file system or an Amazon S3 Files file system.

function_arn class-attribute instance-attribute
function_arn: str | None = None

The function's Amazon Resource Name (ARN).

function_name class-attribute instance-attribute
function_name: str | None = None

The name of the function.

handler class-attribute instance-attribute
handler: str | None = None

The function that Lambda calls to begin running your function.

image_config_response class-attribute instance-attribute
image_config_response: ImageConfigResponse | None = None

The function's image configuration values.

kms_key_arn class-attribute instance-attribute
kms_key_arn: str | None = None

The ARN of the Key Management Service (KMS) customer managed key that's used to encrypt the following resources:

  • The function's environment variables.

  • The function's Lambda SnapStart snapshots.

  • When used with SourceKMSKeyArn, the unzipped version of the .zip deployment package that's used for function invocations. For more information, see Specifying a customer managed key for Lambda.

  • The optimized version of the container image that's used for function invocations. Note that this is not the same key that's used to protect your container image in the Amazon Elastic Container Registry (Amazon ECR). For more information, see Function lifecycle.

If you don't provide a customer managed key, Lambda uses an Amazon Web Services owned key or an Amazon Web Services managed key.

last_modified class-attribute instance-attribute
last_modified: str | None = None

The date and time that the function was last updated, in ISO-8601 format (YYYY-MM-DDThh:mm:ss.sTZD).

last_update_status class-attribute instance-attribute
last_update_status: LastUpdateStatus | None = None

The status of the last update that was performed on the function. This is first set to Successful after function creation completes.

last_update_status_reason class-attribute instance-attribute
last_update_status_reason: str | None = None

The reason for the last update that was performed on the function.

last_update_status_reason_code class-attribute instance-attribute
last_update_status_reason_code: LastUpdateStatusReasonCode | None = None

The reason code for the last update that was performed on the function.

layers class-attribute instance-attribute
layers: list[Layer] | None = None

The function's layers.

logging_config class-attribute instance-attribute
logging_config: LoggingConfig | None = None

The function's Amazon CloudWatch Logs configuration settings.

master_arn class-attribute instance-attribute
master_arn: str | None = None

For Lambda@Edge functions, the ARN of the main function.

memory_size class-attribute instance-attribute
memory_size: int | None = None

The amount of memory available to the function at runtime.

package_type class-attribute instance-attribute
package_type: PackageType | None = None

The type of deployment package. Set to Image for container image and set Zip for .zip file archive.

revision_id class-attribute instance-attribute
revision_id: str | None = None

The latest updated revision of the function or alias.

role class-attribute instance-attribute
role: str | None = None

The function's execution role.

runtime class-attribute instance-attribute
runtime: Runtime | None = None

The identifier of the function's runtime. Runtime is required if the deployment package is a .zip file archive. Specifying a runtime results in an error if you're deploying a function using a container image.

The following list includes deprecated runtimes. Lambda blocks creating new functions and updating existing functions shortly after each runtime is deprecated. For more information, see Runtime use after deprecation.

For a list of all currently supported runtimes, see Supported runtimes.

runtime_version_config class-attribute instance-attribute
runtime_version_config: RuntimeVersionConfig | None = None

The ARN of the runtime and any errors that occured.

signing_job_arn class-attribute instance-attribute
signing_job_arn: str | None = None

The ARN of the signing job.

signing_profile_version_arn class-attribute instance-attribute
signing_profile_version_arn: str | None = None

The ARN of the signing profile version.

snap_start class-attribute instance-attribute
snap_start: SnapStartResponse | None = None

Set ApplyOn to PublishedVersions to create a snapshot of the initialized execution environment when you publish a function version. For more information, see Improving startup performance with Lambda SnapStart.

state class-attribute instance-attribute
state: State | None = None

The current state of the function. When the state is Inactive, you can reactivate the function by invoking it.

state_reason class-attribute instance-attribute
state_reason: str | None = None

The reason for the function's current state.

state_reason_code class-attribute instance-attribute
state_reason_code: StateReasonCode | None = None

The reason code for the function's current state. When the code is Creating, you can't invoke or modify the function.

tenancy_config class-attribute instance-attribute
tenancy_config: TenancyConfig | None = None

The function's tenant isolation configuration settings. Determines whether the Lambda function runs on a shared or dedicated infrastructure per unique tenant.

timeout class-attribute instance-attribute
timeout: int | None = None

The amount of time in seconds that Lambda allows a function to run before stopping it.

tracing_config class-attribute instance-attribute
tracing_config: TracingConfigResponse | None = None

The function's X-Ray tracing configuration.

version class-attribute instance-attribute
version: str | None = None

The version of the Lambda function.

vpc_config class-attribute instance-attribute
vpc_config: VpcConfigResponse | None = None

The function's networking configuration.